unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, db, sqlite3conn, FileUtil, Forms, Controls,
  Graphics, Dialogs, EditBtn, StdCtrls, DBGrids;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    FileNameEdit1: TFileNameEdit;
    SQLite3Connection1: TSQLite3Connection;
    SQLQuery1: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    procedure CreateDB(AFileName: String);
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  LazFileUtils;

{ TForm1 }

procedure TForm1.CreateDB(AFileName: String);
var
  newFile: Boolean;
begin
  SQLite3Connection1.Close;
  newFile := not FileExists(SQLite3Connection1.DatabaseName);
  if newFile then
  begin
    try
      SQLite3Connection1.Open;
      SQLTransaction1.Active := true;
       // Here we're setting up a table named "DATA" in the new database
      SQLite3Connection1.ExecuteDirect(
        'CREATE TABLE "DATA"( '+
          '"Dateiname" CHAR(255), '+
          '"Datei" BLOB )' );
      SQLTransaction1.Commit;
    except
      ShowMessage('Datenbank konnte nicht erstellt werden.');
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  CreateDB('test.db');
  SQLQuery1.Open;
  Button2.Enabled := SQLQuery1.RecordCount > 0;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if FilenameEdit1.FileName = '' then exit;
  if not FileExistsUTF8(FilenameEdit1.Filename) then begin
    ShowMessage('Datei "' + FilenameEdit1.Filename + '" existiert nicht.');
    exit;
  end;

  SQLQuery1.Append;
  TBlobfield(SQLQuery1.fieldByName('Datei')).LoadFromFile(FilenameEdit1.FileName);
  SQLQuery1.FieldByName('Dateiname').AsString := FilenameEdit1.Filename;
  SQLQuery1.Post;
  SQLQuery1.ApplyUpdates;
  Button2.Enabled := true;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  fn: String;
  ext: String;
  n: String;
begin
  fn := SQLQuery1.FieldByName('Dateiname').AsString;
  ext := ExtractFileExt(fn);
  n := ChangeFileExt(fn, '');
  while FileExistsUTF8(n + ext) do
    n := n + 'x';
  fn := n + ext;
  TBlobField(SQLQuery1.FieldByName('Datei')).SaveToFile(fn);
  if FileExists(fn) then
    ShowMessage('Gespeichert als "' + fn + '"') else
    ShowMessage('fehlgeschlagen');
end;


end.

